/' Orx - Portable Game Engine
 *
 * Orx is the legal property of its developers, whose names
 * are listed in the COPYRIGHT file distributed
 * with this source distribution.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 '/

/'*
 * @file orxKernel.h
 * @date 12/09/2005
 * @author iarwain@orx-project.org
 *
 * @todo
 '/

/'*
 * @addtogroup Orx
 *
 * Kernel include file
 *
 * @{
 '/


#ifndef _orxKERNEL_BI
#define _orxKERNEL_BI


/'* Includes all the kernel modules of the engine
 '/

#include "orx/anim/orxAnim.bi"
#include "orx/anim/orxAnimPointer.bi"
#include "orx/anim/orxAnimSet.bi"

#include "orx/core/orxClock.bi"
#include "orx/core/orxConfig.bi"
#include "orx/core/orxEvent.bi"
#include "orx/core/orxLocale.bi"
#include "orx/core/orxSystem.bi"

#include "orx/debug/orxDebug.bi"
#include "orx/debug/orxFPS.bi"

#include "orx/display/orxGraphic.bi"
#include "orx/display/orxDisplay.bi"
#include "orx/display/orxText.bi"
#include "orx/display/orxTexture.bi"

#include "orx/io/orxFile.bi"
#include "orx/io/orxFileSystem.bi"
#include "orx/io/orxInput.bi"
#include "orx/io/orxJoystick.bi"
#include "orx/io/orxKeyboard.bi"
#include "orx/io/orxMouse.bi"

#include "orx/main/orxParam.bi"

#include "orx/math/orxAABox.bi"
#include "orx/math/orxMath.bi"
#include "orx/math/orxOBox.bi"
#include "orx/math/orxVector.bi"

#include "orx/memory/orxBank.bi"
#include "orx/memory/orxMemory.bi"

#include "orx/object/orxFrame.bi"
#include "orx/object/orxObject.bi"
#include "orx/object/orxSpawner.bi"
#include "orx/object/orxStructure.bi"

#include "orx/plugin/orxPlugin.bi"
#include "orx/plugin/orxPluginCore.bi"
#include "orx/plugin/orxPluginUser.bi"

#include "orx/physics/orxBody.bi"
#include "orx/physics/orxPhysics.bi"

#include "orx/render/orxCamera.bi"
#include "orx/render/orxFX.bi"
#include "orx/render/orxFXPointer.bi"
#include "orx/render/orxRender.bi"
#include "orx/render/orxShader.bi"
#include "orx/render/orxShaderPointer.bi"
#include "orx/render/orxViewport.bi"

#include "orx/sound/orxSound.bi"
#include "orx/sound/orxSoundPointer.bi"
#include "orx/sound/orxSoundSystem.bi"


#endif /' _orxKERNEL_BI '/

/'* @} '/
